/*
hchain.c Version 0.2.0  Hash count overflow chains
Copyright (C) 2003-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

int hchain(hshhdr,count,smlen,smlensq,freelen)
hashfmt *hshhdr;
int *count;
int *smlen;
int *smlensq;
int *freelen;
   {
   off_t ofst;
   off_t nextofst;
   int len;
   int lockrslt;
   hshhdr->reason = 0;
   lockrslt = lockf(hshhdr->hndl,F_TEST,0);
   if (lockrslt < 0)
      {
      hshhdr->reason = HASH_ERR + 401;
      return(HASH_ERR + 401);
      } /* can't insert when file is locked */

   ofst = 0;
   *count = *smlen = *smlensq = *freelen = 0;
   ofst = HDRLEN;
   while (ofst < hshhdr->hashend)
      {
      nextofst = hgetptr(hshhdr,ofst);
      if (hshhdr->reason) return(hshhdr->reason);
      if (nextofst && nextofst != UINT_MAX)
	 {
         (*count)++;
         len = 0;
	 while (nextofst)
	    {
	    len++;
            nextofst = hgetptr(hshhdr,nextofst);
            if (hshhdr->reason) return(hshhdr->reason);
	    } /* follow chain */
	 (*smlen) += len;
	 (*smlensq) += (len * len);
	 } /* ovfl chain */
      ofst += hshhdr->rcdnode;
      } /* for each hash record */

   if (hshhdr->freestk)
      {
      ofst = hshhdr->freestk;
      while (ofst)
	 {
	 (*freelen)++;
         ofst = hgetptr(hshhdr,ofst);
         if (hshhdr->reason) return(hshhdr->reason);
	 } /* for each free block */
      } /* count free stack len */
   return(0);
   } /* hchain */
